<?php
/**
 * Created by PhpStorm.
 * User: MATHEUSSILVA
 * Date: 10/04/2015
 * Time: 09:37
 */

namespace Folha\Logic\ValesBeneficios\IntegracaoEletronicaVT;


class LeitorOtimoII extends Leitor
{
    protected $formatosAceitos = 'XLSX|XLSM|XLTX|XLTM|XLS|XLT|ODS|OTS|SLK|XML';

    /**
     * Abre o arquivo que contém a informação de saldo disponível do vale-transporte.
     * @param String $caminho
     * @return mixed
     */
    protected function abrirArquivo( $caminho)
    {
        /** @var \PHPExcel $info */
        $info = \PHPExcel_IOFactory::load($caminho);
        $info->setActiveSheetIndex(0);

        return $info;
    }


    /**
     * Cria um Array contendo Arrays no formato:
     * [
     *     NUMERO_CARTAO : '',
     *     SALDO_CARTAO : ''
     * ]
     * @param mixed $info
     * @return Array
     * @throws ExcessaoIntegracaoVT
     * @throws \Exception
     */
    protected function preparaInfo( $info) {
        $idLinha = 4;
        $idColCartao = 'D';
        $idColSaldo = 'E';
        $idColMatricula = 'A';
        $idColNome = 'B';
        $idColTipo = 'C';
        $infoFinal = array();

        $numCartao = $info->getActiveSheet()->getCell($idColCartao.$idLinha)->getValue();
        $saldo = $info->getActiveSheet()->getCell($idColSaldo.$idLinha)->getValue();
        $matricula = $info->getActiveSheet()->getCell($idColMatricula.$idLinha)->getValue();
        $nome = $info->getActiveSheet()->getCell($idColNome.$idLinha)->getValue();
        $tipo = $info->getActiveSheet()->getCell($idColTipo.$idLinha)->getValue();
        $idLinha++;
        while(!empty($numCartao)){
            $reg = array();
            $reg['NUMERO_CARTAO'] = $numCartao;
            $reg['SALDO_CARTAO'] = $saldo;
            $reg['MATRICULA'] = $matricula;
            $reg['NOME'] = $nome;
            $reg['TIPO'] = $tipo;

            $numCartao = $info->getActiveSheet()->getCell($idColCartao.$idLinha)->getValue();
            $saldo = $info->getActiveSheet()->getCell($idColSaldo.$idLinha)->getValue();
            $matricula = $info->getActiveSheet()->getCell($idColMatricula.$idLinha)->getValue();
            $nome = $info->getActiveSheet()->getCell($idColNome.$idLinha)->getValue();
            $tipo = $info->getActiveSheet()->getCell($idColTipo.$idLinha)->getValue();
            $idLinha++;

            $infoFinal[] = $reg;
        }

        return $infoFinal;
    }
}