/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCONS                                                 */
/* Tabela : TIPOCONS                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 14/05/2004 - RENATA DINIZ                                                  */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOCONS' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOCONS
GO

CREATE TRIGGER DTULTATU_TIPOCONS
ON TIPOCONS
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOCONS', null, 'CDTIPOCONS='+ CDTIPOCONS + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOCONS
      SET DTULTATUTCON = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(TIPOCONS.CDTIPOCONS ,0) = ISNULL(INSERTED.CDTIPOCONS ,0));
   END;
END;
GO

UPDATE TIPOCONS SET DTULTATUTCON = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUTCON IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUTCON' and
            type = 'D')
   ALTER TABLE TIPOCONS DROP CONSTRAINT DEFAULT_DTULTATUTCON
GO

ALTER TABLE TIPOCONS ADD CONSTRAINT DEFAULT_DTULTATUTCON
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUTCON
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TIPOCONS','4.11.194';
GO

