CREATE OR REPLACE
PROCEDURE EMPENHO_OL
  (P_NRSEQCONSOL  IN CONSSOLOL.NRSEQUCONSOL%TYPE,
   P_CDFILIOPELOG IN FILIAL.CDFILIAL%TYPE,
   P_CDFILSOLI    IN FILIAL.CDFILIAL%TYPE,
   P_CDPRODESTO   IN PRODUTO.CDPRODUTO%TYPE,
   P_CDOPERADOR   IN OPERADOR.CDOPERADOR%TYPE,
   P_NRNECECOMP   IN TRABNECECOMP.NRNECECOMP%TYPE DEFAULT NULL,
   P_PREVISAOCONSUMO IN  VARCHAR2 DEFAULT 'N')
IS
   W_S CHAR(1) := 'S';
   W_N CHAR(1) := 'N';
   V_NRSOLCOMP    VARCHAR2(200);
   V_DTULTENTR     DATE;  /* ULTIMA ENTREGA NA CONSOLIDAO DO PRODUTO */
   V_QTARRED       FLOAT; /* QUANTIDADE SOLICITADA ARREDONDADA PARA BAIXO */
   V_QTSOLIPROD    FLOAT; /* QUANTIDADE DA SOLICITACAO DE COMPRAS */
   V_QTAEMPENHAR   FLOAT; /* QUANTIDADE NA UNIDADE DE ESTOQUE QUE ESTA SOBRANDO POR PRODUTO/FILIAL */
   V_VRARREDEMPE   FLOAT; /* ARREDONDAMENTO PARA EMPENHO NA AF */
   V_QTARETIRAR    FLOAT; /* QUANTIDADE QUE SERA RETIRADA DO(S) PROXIMO(S) ITEM DE SOLICITACAO */
   V_QTDISPONIVEL  FLOAT; /* QUANTIDADE DISPONIVEL PARA REMANEJAMENTO */
   V_VRFATOCONV    FLOAT;
   V_QTDEAUX       FLOAT;
   V_QTDETOTALSOL  FLOAT;
   V_QTDESOLDEPOIS FLOAT;
   V_QTDERESTSOL   FLOAT;
   V_COUNT         FLOAT;
   V_QTARRED_AUX   FLOAT := 0; /*QTDE A RETIRAR DA SOLICITACAO*/
   V_CDFORNEOL     FORNECEDOR.CDFORNECED%TYPE;
   V_QTDEAUX1      FLOAT;
   V_REJEICAOOL    FLOAT; /* PORCENTAGEM DE REJEIO*/
   V_VRFATCONVOL   FLOAT;
   V_QTDFINAL      FLOAT;
   V_VRFATOCONV_I  FLOAT;
   V_ROWID         VARCHAR2(200);
   V_ARREDCMPROWID FLOAT;
   V_AJUSTAR       FLOAT;
   V_CDPRODEMPENHO VARCHAR2(10);
   V_COUNT_MIX     FLOAT;
BEGIN
   V_QTAEMPENHAR := 0;
   SELECT
      MAX(CDFORNOPELOG)
   INTO
      V_CDFORNEOL
   FROM
      FILIAL
   WHERE
      FILIAL.CDFILIAL = P_CDFILIOPELOG;
   -- necessrio o NVL para evitar operaes com Null, que sempre retornam Null.
   SELECT NVL(MAX(P.VRFATOCONV), 1)
    INTO V_VRFATOCONV_I
    FROM
       RELACONSOLOL R, PRODUTO P
    WHERE R.NRSEQUCONSOL = P_NRSEQCONSOL
      AND R.CDFILSOLCONS = P_CDFILIOPELOG
      AND P.CDPRODESTO   = P_CDPRODESTO
      AND R.CDFILSOLI    = P_CDFILSOLI
      AND P.CDPRODUTO    = R.CDPRODUTOCONS
      AND NVL(P_PREVISAOCONSUMO, W_N) = W_N;

   SELECT COUNT(DISTINCT P.CDPRODUTO)
    INTO V_COUNT_MIX
    FROM
       RELACONSOLOL R, PRODUTO P
    WHERE R.NRSEQUCONSOL = P_NRSEQCONSOL
      AND R.CDFILSOLCONS = P_CDFILIOPELOG
      AND P.CDPRODESTO   = P_CDPRODESTO
      AND R.CDFILSOLI    = P_CDFILSOLI
      AND P.CDPRODUTO    = R.CDPRODUTOCONS;

   SELECT
      SUM((SELECT
              NVL(SUM(R.QTENTRCONS*P.VRFATOCONV), 0)
           FROM
              RELACONSOLOL R, PRODUTO P
           WHERE R.NRSEQUCONSOL = P_NRSEQCONSOL
             AND R.CDFILSOLCONS = P_CDFILIOPELOG
             AND P.CDPRODESTO   = P_CDPRODESTO
             AND R.CDFILSOLI    = P_CDFILSOLI
             AND P.CDPRODUTO    = R.CDPRODUTOCONS
             AND NVL(P_PREVISAOCONSUMO, W_N) = W_N) -
          ( SELECT SUM(QTSOLIPROD*V_VRFATOCONV_I) FROM
          (SELECT
              NVL(SUM(IT.QTSOLIPROD*PR.VRFATOCONV), 0)/V_VRFATOCONV_I QTSOLIPROD, IT.DTPROGENTR, PR.VRFATOCONV
           FROM
              ITEMSOLI IT, PRODUTO PR
           WHERE IT.CDFILSOLI             = P_CDFILSOLI
             AND PR.CDPRODESTO            = P_CDPRODESTO
             AND PR.CDPRODUTO             = IT.CDPRODUTO
             AND IT.CDFILSOLI            <> P_CDFILIOPELOG
             AND NVL(IT.IDSOLIAPROV, W_S) = W_S
             AND NVL(IT.IDITMCONS, W_N)   = W_N
             AND IT.CDFILIOPELOG          = P_CDFILIOPELOG
             AND IT.NRSEQUCONSOL          = P_NRSEQCONSOL
             AND NVL(P_PREVISAOCONSUMO, W_N) = W_N
           GROUP BY IT.DTPROGENTR, PR.VRFATOCONV)
            ) +
           (
            SELECT NVL(SUM(TB.QTTEORNECCMP*PT.VRFATOCONV), 0)
            FROM TRABNECECOMP TB, PRODUTO PT
            WHERE TB.CDFILIOPELOG = P_CDFILIOPELOG
              AND TB.CDFILNECECMP = P_CDFILSOLI
              AND PT.CDPRODESTO   = P_CDPRODESTO
              AND PT.CDPRODUTO    = TB.CDPRODNECCMP
              AND TB.NRNECECOMP   = P_NRNECECOMP
              AND NVL(P_PREVISAOCONSUMO, W_N) = W_S
            )
          )
   INTO
      V_QTAEMPENHAR
   FROM
      DUAL;
   SELECT
      SUM(VALOR)
   INTO
      V_QTDETOTALSOL
   FROM
   (
      SELECT
         SUM(IT.QTSOLIPROD * NVL(PR.VRFATOCONV, 1)) AS VALOR
      FROM
         ITEMSOLI IT, PRODUTO PR
      WHERE IT.CDFILSOLI             = P_CDFILSOLI
        AND PR.CDPRODESTO            = P_CDPRODESTO
        AND PR.CDPRODUTO             = IT.CDPRODUTO
        AND IT.CDFILSOLI            <> P_CDFILIOPELOG
        AND NVL(IT.IDSOLIAPROV, W_S) = W_S
        AND NVL(IT.IDITMCONS, W_N)   = W_N
        AND IT.CDFILIOPELOG          = P_CDFILIOPELOG
        AND IT.NRSEQUCONSOL          = P_NRSEQCONSOL
        AND NVL(P_PREVISAOCONSUMO, W_N) = W_N
      UNION ALL
      SELECT SUM(TB.QTTEORNECCMP*NVL(PT.VRFATOCONV, 1)) AS VALOR
      FROM TRABNECECOMP TB, PRODUTO PT
      WHERE TB.CDFILIOPELOG = P_CDFILIOPELOG
        AND TB.CDFILNECECMP = P_CDFILSOLI
        AND PT.CDPRODESTO   = P_CDPRODESTO
        AND PT.CDPRODUTO    = TB.CDPRODNECCMP
        AND TB.NRNECECOMP   = P_NRNECECOMP
        AND NVL(P_PREVISAOCONSUMO, W_N) = W_S
   );
   IF (V_QTAEMPENHAR > 0) AND (V_COUNT_MIX = 1)THEN
      V_QTARETIRAR  := 0;
      IF P_PREVISAOCONSUMO = W_N THEN
         FOR C_ITEMCONSSOLOL IN
            (SELECT DISTINCT
                I.CDFILSOLI,
                I.CDFILLAN,
                I.CDPRODUTO,
                I.DTENTRCONSOL,
                I.QTENTRCONSOL,
                NVL(P.VRFATOCONV, 1) VRFATOCONV,
                NVL(P.VRARREDCMP, 1) VRARREDCMP,
                R.DTPROGENTR
             FROM
                ITEMCONSSOLOL I, PRODUTO P, RELACONSOLOL R
             WHERE I.NRSEQUCONSOL = P_NRSEQCONSOL
               AND I.CDFILSOLI    = P_CDFILIOPELOG
               AND P.CDPRODESTO   = P_CDPRODESTO
               AND P.CDPRODUTO    = I.CDPRODUTO
               AND I.NRSEQUCONSOL = R.NRSEQUCONSOL
               --AND I.CDFILLAN     = R.CDFILLAN      /*ALTERAO SAPORE 28-10-2016*/
               AND I.DTENTRCONSOL = R.DTENTRCONSOL
               AND I.CDPRODUTO    = R.CDPRODUTOCONS
               AND R.CDFILSOLI    = P_CDFILSOLI
               AND NVL(P_PREVISAOCONSUMO, W_N) = W_N
             ORDER BY
               R.DTPROGENTR)
         LOOP
            V_VRARREDEMPE := 0;
            SELECT
               NVL(MAX(VRARREDEMPE), 0)
            INTO
               V_VRARREDEMPE
            FROM
               PRODFORNCOMP
            WHERE
               (CDFORNECED  = V_CDFORNEOL) AND
               (CDPRODCOMPL = C_ITEMCONSSOLOL.CDPRODUTO);
            IF V_VRARREDEMPE > 0 THEN
               IF V_QTARETIRAR > 0 THEN  /* SE ALGUM ITEM DE SOLICITACAO TEVE SUA QUANTIDADE AUMENTADA, ESTE "IF" IRA COMPLETAR O REMANEJAMENTO DIMINUINDO A QUANTIDADE */
                  SELECT
                     MAX(R.NRSOLICMP||R.CDFILLAN||R.CDPRODUTO||TO_CHAR(R.DTPROGENTR, 'DD/MM/YYYY'))
                   INTO
                     V_NRSOLCOMP
                  FROM
                     RELACONSOLOL R
                  WHERE C_ITEMCONSSOLOL.CDFILSOLI     = R.CDFILSOLCONS
                    AND C_ITEMCONSSOLOL.CDFILLAN      = R.CDFILLANCONS
                    AND C_ITEMCONSSOLOL.CDPRODUTO     = R.CDPRODUTOCONS
                    AND C_ITEMCONSSOLOL.DTPROGENTR    = R.DTPROGENTR
                    AND P_NRSEQCONSOL                 = R.NRSEQUCONSOL
                    AND P_CDFILSOLI                   = R.CDFILSOLI;
                  SELECT MAX(CEIL((((ITEMSOLI.QTSOLIPROD/C_ITEMCONSSOLOL.VRFATOCONV) * C_ITEMCONSSOLOL.VRFATOCONV)/C_ITEMCONSSOLOL.VRFATOCONV)/
                         CASE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                              WHEN 0
                              THEN 1
                              ELSE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                         END) * CASE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                                     WHEN 0
                                     THEN 1
                                     ELSE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                                 END)
                  INTO V_QTDEAUX
                  FROM ITEMSOLI, PRODUTO
                 WHERE ITEMSOLI.CDFILSOLI  = P_CDFILSOLI
                   AND ITEMSOLI.CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4)
                   AND ITEMSOLI.NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10)
                   AND ITEMSOLI.CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)
                   AND ITEMSOLI.DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                   AND ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO
                   AND ITEMSOLI.NRSEQUCONSOL          = P_NRSEQCONSOL;
                  SELECT
                     MAX(ITEMSOLI.QTSOLIPROD * PRODUTO.VRFATOCONV) INTO V_QTSOLIPROD
                  FROM
                     ITEMSOLI,
                     PRODUTO
                  WHERE ITEMSOLI.CDFILSOLI  = P_CDFILSOLI
                    AND ITEMSOLI.CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4)
                    AND ITEMSOLI.NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10)
                    AND ITEMSOLI.CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)
                    AND ITEMSOLI.DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                    AND ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO
                    AND ITEMSOLI.NRSEQUCONSOL          = P_NRSEQCONSOL;
                  IF V_QTSOLIPROD <= V_QTARETIRAR THEN /* O ITEM DA SOLICITACAO SERA EXCLUIDO CASO TENHA QUE RETIRAR UMA QUANTIDADE MAIOR QUE A SUA PROPRIA */
                     /* LOG DE ALTERAO */
                     INSERT INTO MOVOPSOL
                       (CDFILSOLMOV,
                        CDFILLANMOV,
                        NRSOLIMOV,
                        CDPRODUTO,
                        DTENTROPER,
                        DTOPERSOL,
                        CDOPERADOR,
                        QTANTOPER,
                        QTDEPOPER,
                        DSJUSTOPER)
                     VALUES
                       (P_CDFILSOLI,
                        SUBSTR(V_NRSOLCOMP, 11, 4),
                        SUBSTR(V_NRSOLCOMP, 1, 10),
                        SUBSTR(V_NRSOLCOMP, 15, 10),
                        TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY'),
                        SYSDATE,
                        P_CDOPERADOR,
                        V_QTSOLIPROD,
                        0,
                        'EMPENHO DE OL');
                     DELETE FROM ITEMSOLI
                     WHERE
                        (CDFILSOLI  = P_CDFILSOLI)    AND
                        (CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4))  AND
                        (NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10))  AND
                        (CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)) AND
                        (DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY'));
                     IF C_ITEMCONSSOLOL.QTENTRCONSOL > V_QTDEAUX THEN
                        UPDATE ITEMCONSSOLOL
                           SET QTENTRCONSOL = QTENTRCONSOL - V_QTDEAUX
                         WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                           AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                           AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                           AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL
                           AND NRSEQUCONSOL = P_NRSEQCONSOL
                           AND QTENTRCONSOL - V_QTDEAUX > 0;
                        IF SQL%NOTFOUND THEN
                           DELETE FROM ITEMCONSSOLOL
                            WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                              AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                              AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                              AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL
                              AND NRSEQUCONSOL = P_NRSEQCONSOL;
                        END IF;
                     ELSE
                        DELETE FROM ITEMCONSSOLOL
                        WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                          AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                          AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                          AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL
                          AND NRSEQUCONSOL = P_NRSEQCONSOL;
                     END IF;
                     V_QTARETIRAR  := V_QTARETIRAR  - V_QTSOLIPROD;
                     V_QTAEMPENHAR := V_QTAEMPENHAR - (V_QTDEAUX * C_ITEMCONSSOLOL.VRFATOCONV);
                  ELSE
                     V_QTDEAUX1 := 0;
                     /* LOG DE ALTERAO */
                     INSERT INTO MOVOPSOL
                       (CDFILSOLMOV,
                        CDFILLANMOV,
                        NRSOLIMOV,
                        CDPRODUTO,
                        DTENTROPER,
                        DTOPERSOL,
                        CDOPERADOR,
                        QTANTOPER,
                        QTDEPOPER,
                        DSJUSTOPER)
                     SELECT
                        ITEMSOLI.CDFILSOLI,
                        ITEMSOLI.CDFILLAN,
                        ITEMSOLI.NRSOLICMP,
                        ITEMSOLI.CDPRODUTO,
                        ITEMSOLI.DTPROGENTR,
                        SYSDATE,
                        P_CDOPERADOR,
                        ITEMSOLI.QTSOLIPROD,
                        ITEMSOLI.QTSOLIPROD - V_QTARETIRAR,
                        'EMPENHO DE OL'
                     FROM
                        ITEMSOLI
                     WHERE
                        (ITEMSOLI.CDFILSOLI  = P_CDFILSOLI)    AND
                        (ITEMSOLI.CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4))  AND
                        (ITEMSOLI.NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10))  AND
                        (ITEMSOLI.CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)) AND
                        (ITEMSOLI.DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY'));
                     UPDATE ITEMSOLI
                     SET QTSOLIPROD = QTSOLIPROD - V_QTARETIRAR
                     WHERE
                        (CDFILSOLI  = P_CDFILSOLI)    AND
                        (CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4))  AND
                        (NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10))  AND
                        (CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)) AND
                        (QTSOLIPROD > V_QTARETIRAR)                AND
                        (DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY'));
                     /*RETIRA ENTREGA DO OL QUANDO AJUSTA SOLICIAO DA FILIAL PARA QUANTIDADE MENOR*/
                     V_QTDEAUX1 := CEIL(((V_QTSOLIPROD - V_QTARETIRAR)/C_ITEMCONSSOLOL.VRFATOCONV)/
                                   CASE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                                        WHEN 0
                                        THEN 1
                                        ELSE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                                    END) * CASE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                                        WHEN 0
                                        THEN 1
                                        ELSE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                                    END;
                     IF V_QTDEAUX1 > 0 THEN
                        IF V_QTDEAUX < V_QTDEAUX1 THEN
                           DELETE FROM ITEMCONSSOLOL
                           WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                             AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                             AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                             AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL
                             AND NRSEQUCONSOL = P_NRSEQCONSOL;
                        END IF;
                        IF V_QTDEAUX > V_QTDEAUX1 THEN
                           UPDATE ITEMCONSSOLOL
                              SET QTENTRCONSOL = QTENTRCONSOL - 1*C_ITEMCONSSOLOL.VRARREDCMP
                            WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                              AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                              AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                              AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL
                              AND NRSEQUCONSOL = P_NRSEQCONSOL
                              AND QTENTRCONSOL - C_ITEMCONSSOLOL.VRARREDCMP > 0;
                           IF SQL%NOTFOUND THEN
                              DELETE
                                FROM ITEMCONSSOLOL
                               WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                                 AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                                 AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                                 AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL
                                 AND NRSEQUCONSOL = P_NRSEQCONSOL;
                           END IF;
                        END IF;
                     END IF;
                     V_QTARETIRAR := 0;
                  END IF;
               END IF;
               IF V_QTARETIRAR = 0 THEN  /* SE O REMANEJAMENTO DAS ENTREGAS ANTERIORES FOI FINALIZADO NO "IF" ACIMA, ESTE "IF" IRA VERIFICAR SE SERA NECESSARIO FAZER OUTRO REMANEJAMENTO PUXANDO DE ENTREGAS FUTURAS */
                  SELECT
                     MAX(R.NRSOLICMP||R.CDFILLAN||R.CDPRODUTO||TO_CHAR(R.DTPROGENTR, 'DD/MM/YYYY'))
                  INTO
                     V_NRSOLCOMP
                  FROM
                     RELACONSOLOL R
                  WHERE C_ITEMCONSSOLOL.CDFILSOLI     = R.CDFILSOLCONS
                    AND C_ITEMCONSSOLOL.CDFILLAN      = R.CDFILLANCONS
                    AND C_ITEMCONSSOLOL.CDPRODUTO     = R.CDPRODUTOCONS
                    AND C_ITEMCONSSOLOL.DTPROGENTR    = R.DTPROGENTR
                    AND P_NRSEQCONSOL                 = R.NRSEQUCONSOL
                    AND P_CDFILSOLI                   = R.CDFILSOLI;
                SELECT MAX(CEIL((((ITEMSOLI.QTSOLIPROD/C_ITEMCONSSOLOL.VRFATOCONV) * C_ITEMCONSSOLOL.VRFATOCONV)/C_ITEMCONSSOLOL.VRFATOCONV)/
                       CASE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                            WHEN 0
                            THEN 1
                            ELSE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                       END) * CASE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                                   WHEN 0
                                   THEN 1
                                   ELSE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 1)
                               END)
                  INTO V_QTDEAUX
                  FROM ITEMSOLI, PRODUTO
                 WHERE ITEMSOLI.CDFILSOLI  = P_CDFILSOLI
                   AND ITEMSOLI.CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4)
                   AND ITEMSOLI.NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10)
                   AND ITEMSOLI.CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)
                   AND ITEMSOLI.DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                   AND ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO
                   AND ITEMSOLI.NRSEQUCONSOL          = P_NRSEQCONSOL;
                  IF V_NRSOLCOMP IS NOT NULL THEN  /* SE AINDA EXITIR SOLICITACAO PARA ESTA ENTREGA... */
                     SELECT
                        MAX(ITEMSOLI.QTSOLIPROD * PRODUTO.VRFATOCONV) INTO V_QTSOLIPROD
                     FROM
                        ITEMSOLI,
                        PRODUTO
                     WHERE ITEMSOLI.CDFILSOLI  = P_CDFILSOLI
                       AND ITEMSOLI.CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4)
                       AND ITEMSOLI.NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10)
                       AND ITEMSOLI.CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)
                       AND ITEMSOLI.DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                       AND ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO;
                     V_QTARETIRAR := (V_QTDEAUX * C_ITEMCONSSOLOL.VRFATOCONV) - V_QTSOLIPROD;
                     IF V_QTARETIRAR > 0 THEN
   /*################################ AJUSTANDO V_QTARETIRAR PARA O VALOR QUE TEM DISPONIVEL PARA REMANEJAR ###############################*/
                        SELECT
                           MAX(R.DTPROGENTR)
                        INTO
                           V_DTULTENTR
                        FROM
                           RELACONSOLOL R
                        WHERE R.CDPRODUTOCONS = C_ITEMCONSSOLOL.CDPRODUTO
                          AND R.CDFILSOLCONS  = C_ITEMCONSSOLOL.CDFILSOLI
                          AND R.CDFILSOLI     = P_CDFILSOLI
                          AND R.NRSEQUCONSOL  = P_NRSEQCONSOL;
                        SELECT
                           SUM(ITEMSOLI.QTSOLIPROD * PRODUTO.VRFATOCONV) INTO V_QTDISPONIVEL
                        FROM
                           ITEMSOLI,
                           PRODUTO
                        WHERE ITEMSOLI.CDFILSOLI  =  P_CDFILSOLI
                          AND PRODUTO.CDPRODESTO  =  P_CDPRODESTO
                          AND ITEMSOLI.DTPROGENTR >  TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                          AND ITEMSOLI.DTPROGENTR <= V_DTULTENTR
                          AND ITEMSOLI.CDPRODUTO  =  PRODUTO.CDPRODUTO
                          AND ITEMSOLI.NRSEQUCONSOL          = P_NRSEQCONSOL;
                        IF NVL(V_QTDISPONIVEL, 0) > 0 THEN
                           IF V_QTARETIRAR > NVL(V_QTDISPONIVEL, 0) THEN
                              V_QTARETIRAR := NVL(V_QTDISPONIVEL, 0);
                           END IF;
                        END IF;
                        /*ALTERAO DAVIDSON*/
                        V_QTARRED       := V_QTARETIRAR/C_ITEMCONSSOLOL.VRFATOCONV;
                        IF C_ITEMCONSSOLOL.VRFATOCONV > 0 AND C_ITEMCONSSOLOL.VRFATOCONV < 1 THEN
                           V_QTARRED       := V_QTARETIRAR;
                        END IF;
                        V_QTARRED_AUX := 0;
                        /*ALTERAAO V_QTARETIRAR POR V_QTSOLIPROD*/
                        IF V_QTSOLIPROD > 0 AND V_QTSOLIPROD < 1 THEN
                           V_QTARRED_AUX   := V_QTARRED*C_ITEMCONSSOLOL.VRFATOCONV;
                        END IF;
                        IF C_ITEMCONSSOLOL.VRARREDCMP > 0 THEn
                           V_QTARRED := FLOOR(V_QTARRED / C_ITEMCONSSOLOL.VRARREDCMP) * C_ITEMCONSSOLOL.VRARREDCMP; /* TEM QUE ARREDONDAR PARA BAIXO PARA NAO TIRAR MAIS DO QUE DEVIA */
                        END IF;
                        IF V_VRARREDEMPE > 0 THEN
                           V_QTARRED := FLOOR(V_QTARRED / V_VRARREDEMPE) * V_VRARREDEMPE; /* TEM QUE ARREDONDAR PARA BAIXO PARA NAO TIRAR MAIS DO QUE DEVIA */
                        END IF;
                        IF V_QTARRED > 0 THEN
                           IF C_ITEMCONSSOLOL.QTENTRCONSOL > V_QTARRED THEN
                              UPDATE ITEMCONSSOLOL
                              SET QTENTRCONSOL   = QTENTRCONSOL - V_QTARRED
                              WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                                AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                                AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                                AND NRSEQUCONSOL = P_NRSEQCONSOL
                                AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL
                                AND QTENTRCONSOL - V_QTARRED > 0;
                              IF SQL%NOTFOUND THEN
                                 DELETE
                                   FROM ITEMCONSSOLOL
                                 WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                                   AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                                   AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                                   AND NRSEQUCONSOL = P_NRSEQCONSOL
                                   AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL;
                              END IF;
                              V_QTAEMPENHAR := V_QTAEMPENHAR - (V_QTARRED * C_ITEMCONSSOLOL.VRFATOCONV);
                              V_QTARETIRAR  := V_QTARETIRAR - (V_QTARRED * C_ITEMCONSSOLOL.VRFATOCONV);
                           END IF;
                        ELSE
                           IF V_QTARRED_AUX > 0 THEN
                              SELECT
                                 MAX(PRODUTO.VRFATOCONV) INTO V_VRFATOCONV
                              FROM
                                 ITEMSOLI,
                                 PRODUTO
                              WHERE ITEMSOLI.CDFILSOLI  = P_CDFILSOLI
                                AND ITEMSOLI.CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4)
                                AND ITEMSOLI.NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10)
                                AND ITEMSOLI.CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)
                                AND ITEMSOLI.DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                                AND ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO;
                              V_QTAEMPENHAR := V_QTAEMPENHAR - (V_QTARRED_AUX * V_VRFATOCONV);
                              V_QTARETIRAR  := V_QTARETIRAR  - (V_QTARRED_AUX * V_VRFATOCONV);
                              /*ALTERAAO DAVIDSON DE V_QTARETIRAR = 0 PARA V_QTARETIRAR <= 0*/
                              IF (V_QTARRED_AUX * V_VRFATOCONV) > 0 AND V_QTARETIRAR <= 0 THEN
                                 V_QTARETIRAR := (V_QTARRED_AUX * V_VRFATOCONV);
                              END IF;
                           END IF;
                        END IF;
                        IF V_QTARETIRAR > 0 THEN
                           IF V_QTARETIRAR <= V_QTAEMPENHAR THEN
                              SELECT
                                 MAX(PRODUTO.VRFATOCONV) INTO V_VRFATOCONV
                              FROM
                                 ITEMSOLI,
                                 PRODUTO
                              WHERE ITEMSOLI.CDFILSOLI  = P_CDFILSOLI
                                AND ITEMSOLI.CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4)
                                AND ITEMSOLI.NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10)
                                AND ITEMSOLI.CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)
                                AND ITEMSOLI.DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                                AND ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO;
                              /* LOG DE ALTERAO */
                              INSERT INTO MOVOPSOL
                                (CDFILSOLMOV,
                                 CDFILLANMOV,
                                 NRSOLIMOV,
                                 CDPRODUTO,
                                 DTENTROPER,
                                 DTOPERSOL,
                                 CDOPERADOR,
                                 QTANTOPER,
                                 QTDEPOPER,
                                 DSJUSTOPER)
                              SELECT
                                 ITEMSOLI.CDFILSOLI,
                                 ITEMSOLI.CDFILLAN,
                                 ITEMSOLI.NRSOLICMP,
                                 ITEMSOLI.CDPRODUTO,
                                 ITEMSOLI.DTPROGENTR,
                                 SYSDATE,
                                 P_CDOPERADOR,
                                 ITEMSOLI.QTSOLIPROD,
                                 ITEMSOLI.QTSOLIPROD + V_QTARETIRAR / V_VRFATOCONV,
                                 'EMPENHO DE OL'
                              FROM
                                 ITEMSOLI
                              WHERE ITEMSOLI.CDFILSOLI  = P_CDFILSOLI
                                AND ITEMSOLI.CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4)
                                AND ITEMSOLI.NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10)
                                AND ITEMSOLI.CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)
                                AND ITEMSOLI.DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY');
                              UPDATE ITEMSOLI
                              SET QTSOLIPROD = QTSOLIPROD + V_QTARETIRAR/V_VRFATOCONV
                              WHERE ITEMSOLI.CDFILSOLI  = P_CDFILSOLI
                                AND ITEMSOLI.CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4)
                                AND ITEMSOLI.NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10)
                                AND ITEMSOLI.CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)
                                AND ITEMSOLI.DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY');
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
            --AQUI FATCONV
            V_VRFATCONVOL   := C_ITEMCONSSOLOL.VRFATOCONV;
            V_CDPRODEMPENHO := C_ITEMCONSSOLOL.CDPRODUTO;
            V_ARREDCMPROWID := CASE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 0)
                                  WHEN  0
                                  THEN  1
                                  ELSE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 0)
                               END;
         END LOOP;
         SELECT
            SUM(IT.QTSOLIPROD*NVL(PR.VRFATOCONV, 1))
         INTO
            V_QTDESOLDEPOIS
         FROM
            ITEMSOLI IT, PRODUTO PR
         WHERE IT.CDFILSOLI             = P_CDFILSOLI
           AND PR.CDPRODESTO            = P_CDPRODESTO
           AND PR.CDPRODUTO             = IT.CDPRODUTO
           AND IT.CDFILSOLI            <> P_CDFILIOPELOG
           AND NVL(IT.IDSOLIAPROV, W_S) = W_S
           AND NVL(IT.IDITMCONS, W_N)   = W_N
           AND IT.CDFILIOPELOG          = P_CDFILIOPELOG
           AND IT.NRSEQUCONSOL          = P_NRSEQCONSOL;
         V_QTDERESTSOL := V_QTDESOLDEPOIS - V_QTDETOTALSOL;
         IF V_QTDERESTSOL > 0 THEN
            FOR C_ITEMSOLI_FINAL IN
               (
               SELECT
                  IT.ROWID,
                  IT.CDFILSOLI,
                  IT.CDFILLAN,
                  IT.NRSOLICMP,
                  (IT.QTSOLIPROD*NVL(PR.VRFATOCONV, 1)) QTSOLIPROD,
                  NVL(PR.VRARREDCMP, 0) VRARREDCMP,
                  NVL(PR.VRFATOCONV, 1) VRFATOCONV
               FROM
                  ITEMSOLI IT, PRODUTO PR
               WHERE IT.CDFILSOLI             = P_CDFILSOLI
                 AND PR.CDPRODESTO            = P_CDPRODESTO
                 AND PR.CDPRODUTO             = IT.CDPRODUTO
                 AND IT.CDFILSOLI            <> P_CDFILIOPELOG
                 AND NVL(IT.IDSOLIAPROV, W_S) = W_S
                 AND NVL(IT.IDITMCONS, W_N)   = W_N
                 AND IT.CDFILIOPELOG          = P_CDFILIOPELOG
                 AND IT.NRSEQUCONSOL          = P_NRSEQCONSOL
               ORDER BY
                  DTPROGENTR DESC,
                  (IT.QTSOLIPROD*NVL(PR.VRFATOCONV, 1)) DESC
               )
            LOOP
               IF (V_QTDERESTSOL > 0) THEN
                  V_ROWID := C_ITEMSOLI_FINAL.ROWID;
                  IF C_ITEMSOLI_FINAL.QTSOLIPROD > V_QTDERESTSOL THEN
                     V_QTDEAUX := V_QTDERESTSOL/C_ITEMSOLI_FINAL.VRFATOCONV;
                     IF C_ITEMSOLI_FINAL.VRARREDCMP > 0 THEN
                        V_QTDEAUX := FLOOR(V_QTDEAUX / C_ITEMSOLI_FINAL.VRARREDCMP) * C_ITEMSOLI_FINAL.VRARREDCMP;
                     END IF;
                     IF V_QTDEAUX > 0 THEN
                        /* LOG DE ALTERAO */
                        INSERT INTO MOVOPSOL
                          (CDFILSOLMOV,
                           CDFILLANMOV,
                           NRSOLIMOV,
                           CDPRODUTO,
                           DTENTROPER,
                           DTOPERSOL,
                           CDOPERADOR,
                           QTANTOPER,
                           QTDEPOPER,
                           DSJUSTOPER)
                        SELECT
                           ITEMSOLI.CDFILSOLI,
                           ITEMSOLI.CDFILLAN,
                           ITEMSOLI.NRSOLICMP,
                           ITEMSOLI.CDPRODUTO,
                           ITEMSOLI.DTPROGENTR,
                           SYSDATE,
                           P_CDOPERADOR,
                           ITEMSOLI.QTSOLIPROD,
                           ITEMSOLI.QTSOLIPROD - V_QTDEAUX,
                           'EMPENHO DE OL - SUBTRAI'
                        FROM
                           ITEMSOLI
                        WHERE ROWID = C_ITEMSOLI_FINAL.ROWID
                          AND (ITEMSOLI.QTSOLIPROD - V_QTDEAUX) > 0; /* Includa esta condio porque a quantidade estava ficando negativa na Apetit - 08/08/2016.*/

                        BEGIN
                           UPDATE ITEMSOLI
                           SET QTSOLIORIG = NVL(QTSOLIORIG, QTSOLIPROD),
                               QTSOLIPROD = QTSOLIPROD - V_QTDEAUX
                           WHERE ROWID = C_ITEMSOLI_FINAL.ROWID
                             AND (QTSOLIPROD - V_QTDEAUX) > 0; /* Includa esta condio porque a quantidade estava ficando negativa na Apetit - 08/08/2016. */

                        EXCEPTION
                           WHEN OTHERS THEN BEGIN
                              UPDATE ITEMSOLI
                              SET QTSOLIPROD = QTSOLIPROD - V_QTDEAUX
                              WHERE ROWID = C_ITEMSOLI_FINAL.ROWID;
                           END;
                        END;
                        SELECT MAX(NRSOLICMP||CDFILLAN||CDPRODUTO||TO_CHAR(DTPROGENTR, 'DD/MM/YYYY'))
                          INTO V_NRSOLCOMP
                          FROM ITEMSOLI
                         WHERE ITEMSOLI.ROWID = C_ITEMSOLI_FINAL.ROWID;
                        V_QTDERESTSOL := 0;
                     END IF;
                  ELSE
                     SELECT COUNT(1)
                     INTO V_COUNT
                     FROM ITEMSOLI, PRODUTO P
                     WHERE CDFILSOLI = C_ITEMSOLI_FINAL.CDFILSOLI
                       AND CDFILLAN = C_ITEMSOLI_FINAL.CDFILLAN
                       AND NRSOLICMP = C_ITEMSOLI_FINAL.NRSOLICMP
                       AND P.CDPRODESTO = P_CDPRODESTO
                       AND P.CDPRODUTO = ITEMSOLI.CDPRODUTO;
                     IF NVL(V_COUNT, 0) > 1 THEN
                        /* LOG DE ALTERAO */
                        INSERT INTO MOVOPSOL
                          (CDFILSOLMOV,
                           CDFILLANMOV,
                           NRSOLIMOV,
                           CDPRODUTO,
                           DTENTROPER,
                           DTOPERSOL,
                           CDOPERADOR,
                           QTANTOPER,
                           QTDEPOPER,
                           DSJUSTOPER)
                        SELECT
                           P_CDFILSOLI,
                           CDFILLAN,
                           NRSOLICMP,
                           CDPRODUTO,
                           DTPROGENTR,
                           SYSDATE,
                           P_CDOPERADOR,
                           QTSOLIPROD,
                           0,
                           'EMPENHO DE OL - EXCLUI'
                        FROM ITEMSOLI
                        WHERE ROWID = C_ITEMSOLI_FINAL.ROWID;
                        DELETE FROM ITEMSOLI
                        WHERE ROWID = C_ITEMSOLI_FINAL.ROWID;
                        V_QTDERESTSOL := V_QTDERESTSOL - C_ITEMSOLI_FINAL.QTSOLIPROD;
                     END IF;
                  END IF;
               END IF;
            END LOOP;
         ELSE
            IF V_QTDERESTSOL < 0 THEN
               FOR C_ITEMSOLI_FINAL IN
                  (
                  SELECT
                     IT.ROWID,
                     NVL(PR.VRARREDCMP, 0) VRARREDCMP,
                     NVL(PR.VRFATOCONV, 1) VRFATOCONV
                  FROM
                     ITEMSOLI IT, PRODUTO PR
                  WHERE IT.CDFILSOLI             = P_CDFILSOLI
                    AND PR.CDPRODESTO            = P_CDPRODESTO
                    AND PR.CDPRODUTO             = IT.CDPRODUTO
                    AND IT.CDFILSOLI            <> P_CDFILIOPELOG
                    AND NVL(IT.IDSOLIAPROV, W_S) = W_S
                    AND NVL(IT.IDITMCONS, W_N)   = W_N
                    AND IT.CDFILIOPELOG          = P_CDFILIOPELOG
                    AND IT.NRSEQUCONSOL          = P_NRSEQCONSOL
                  ORDER BY
                     --DTPROGENTR, Alterao 23/12/2016 Sol. 170522
                     (IT.QTSOLIPROD*NVL(PR.VRFATOCONV, 1))
                  )
               LOOP
                  V_ROWID := C_ITEMSOLI_FINAL.ROWID;
                  V_QTDEAUX := ABS(V_QTDERESTSOL/C_ITEMSOLI_FINAL.VRFATOCONV);
                  IF C_ITEMSOLI_FINAL.VRARREDCMP > 0 THEN
                     V_QTDEAUX := CEIL(V_QTDEAUX / C_ITEMSOLI_FINAL.VRARREDCMP) * C_ITEMSOLI_FINAL.VRARREDCMP;
                  END IF;
                  INSERT INTO MOVOPSOL
                    (CDFILSOLMOV,
                     CDFILLANMOV,
                     NRSOLIMOV,
                     CDPRODUTO,
                     DTENTROPER,
                     DTOPERSOL,
                     CDOPERADOR,
                     QTANTOPER,
                     QTDEPOPER,
                     DSJUSTOPER)
                  SELECT
                     ITEMSOLI.CDFILSOLI,
                     ITEMSOLI.CDFILLAN,
                     ITEMSOLI.NRSOLICMP,
                     ITEMSOLI.CDPRODUTO,
                     ITEMSOLI.DTPROGENTR,
                     SYSDATE,
                     P_CDOPERADOR,
                     ITEMSOLI.QTSOLIPROD,
                     ITEMSOLI.QTSOLIPROD + V_QTDEAUX,
                     'EMPENHO DE OL - ACRESCE'
                  FROM
                     ITEMSOLI
                  WHERE ROWID = C_ITEMSOLI_FINAL.ROWID;
                  BEGIN
                      UPDATE ITEMSOLI
                      SET QTSOLIORIG = NVL(QTSOLIORIG, QTSOLIPROD),
                          QTSOLIPROD = QTSOLIPROD + V_QTDEAUX
                      WHERE ITEMSOLI.ROWID = C_ITEMSOLI_FINAL.ROWID;
                  EXCEPTION
                     WHEN OTHERS THEN BEGIN
                        UPDATE ITEMSOLI
                        SET QTSOLIPROD = QTSOLIPROD + V_QTDEAUX
                        WHERE ITEMSOLI.ROWID = C_ITEMSOLI_FINAL.ROWID;
                     END;
                  END;
                  SELECT MAX(NRSOLICMP||CDFILLAN||CDPRODUTO||TO_CHAR(DTPROGENTR, 'DD/MM/YYYY'))
                    INTO V_NRSOLCOMP
                    FROM ITEMSOLI
                   WHERE ITEMSOLI.ROWID = C_ITEMSOLI_FINAL.ROWID;
                  EXIT;
               END LOOP;
            END IF;
         END IF;
         /*
            SE NO POSSUIR VALOR PARA A FILIAL SOLICITANTE, RETORNA O VALOR DA FILIAL OL,
            CASO CONTRRIO RETORNA ZERO E A PROCEDURE NO CONSIDERA O PARMETRO
         */
         SELECT MAX(NVL(PF.VRMINEMPENHOOL, NVL(PFOL.VRMINEMPENHOOL, 0)))
         INTO V_REJEICAOOL
         FROM PRODFILI PF, ITEMSOLI IT, PRODFILI PFOL, PRODUTO
         WHERE IT.CDFILSOLI    = P_CDFILSOLI
           AND IT.CDPRODUTO    = PRODUTO.CDPRODESTO
           AND PF.CDFILIAL     = P_CDFILSOLI
           AND PF.CDPRODUTO    = PRODUTO.CDPRODUTO
           AND PF.CDPRODUTO    = PFOL.CDPRODUTO
           AND PFOL.CDFILIAL   = IT.CDFILIOPELOG
           AND PFOL.CDPRODUTO  = V_CDPRODEMPENHO
           AND NVL(IT.NRSEQUCONSOL, '1') = P_NRSEQCONSOL
           AND NVL(IT.CDFILIOPELOG, '1') = P_CDFILIOPELOG;
         IF V_REJEICAOOL > 0 THEN
            V_AJUSTAR  := V_VRFATCONVOL;
            IF V_VRFATCONVOL = 1 AND V_ARREDCMPROWID > 1 THEN
               V_AJUSTAR := V_ARREDCMPROWID;
            END IF;
            SELECT
               MAX(ITEMSOLI.QTSOLIPROD * PRODUTO.VRFATOCONV) INTO V_QTDFINAL
            FROM
               ITEMSOLI,
               PRODUTO
            WHERE ITEMSOLI.CDFILSOLI  = P_CDFILSOLI
              AND ITEMSOLI.CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4)
              AND ITEMSOLI.NRSOLICMP  = SUBSTR(V_NRSOLCOMP, 1, 10)
              AND ITEMSOLI.CDPRODUTO  = SUBSTR(V_NRSOLCOMP, 15, 10)
              AND ITEMSOLI.DTPROGENTR = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
              AND ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO
              AND ITEMSOLI.NRSEQUCONSOL          = P_NRSEQCONSOL;
            V_QTDFINAL := MOD(V_QTDFINAL, V_AJUSTAR);
            IF (V_QTDFINAL < (V_AJUSTAR*V_REJEICAOOL/100) AND (V_QTDFINAL > 0)) THEN
               FOR C_ITEMCONS IN(
                  SELECT
                     I.ROWID,
                     I.QTENTRCONSOL
                  FROM
                     ITEMCONSSOLOL I, PRODUTO P, RELACONSOLOL R,
                     (
                        SELECT IT.DTPROGENTR, IT.NRSEQUCONSOL
                        FROM ITEMSOLI IT
                        WHERE IT.CDFILSOLI    = P_CDFILSOLI
                          AND IT.CDFILLAN     = SUBSTR(V_NRSOLCOMP, 11, 4)
                          AND IT.NRSOLICMP    = SUBSTR(V_NRSOLCOMP, 1, 10)
                          AND IT.CDPRODUTO    = SUBSTR(V_NRSOLCOMP, 15, 10)
                          AND IT.DTPROGENTR   = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                          AND IT.NRSEQUCONSOL = P_NRSEQCONSOL
                    ) ITS
                  WHERE I.NRSEQUCONSOL = P_NRSEQCONSOL
                    AND I.CDFILSOLI    = P_CDFILIOPELOG
                    AND P.CDPRODESTO   = P_CDPRODESTO
                    AND P.CDPRODUTO    = I.CDPRODUTO
                    AND I.NRSEQUCONSOL = R.NRSEQUCONSOL
                    AND R.NRSEQUCONSOL = ITS.NRSEQUCONSOL
                    AND I.CDFILLAN     = R.CDFILLAN
                    AND I.DTENTRCONSOL = R.DTENTRCONSOL
                    AND I.CDPRODUTO    = R.CDPRODUTOCONS
                    AND R.CDFILSOLI    = P_CDFILSOLI
                    AND R.DTPROGENTR   = ITS.DTPROGENTR
               ) LOOP
                  IF V_VRFATCONVOL = 1 AND V_ARREDCMPROWID > 1 THEN
                     UPDATE ITEMCONSSOLOL
                     SET QTENTRCONSOL = QTENTRCONSOL - 1*V_AJUSTAR
                     WHERE ROWID = C_ITEMCONS.ROWID
                       AND QTENTRCONSOL > 1*V_AJUSTAR;
                     IF SQL%NOTFOUND THEN
                        DELETE ITEMCONSSOLOL
                        WHERE ROWID = C_ITEMCONS.ROWID;
                     END IF;
                  ELSE
                     UPDATE ITEMCONSSOLOL
                     SET QTENTRCONSOL = QTENTRCONSOL - 1
                     WHERE ROWID = C_ITEMCONS.ROWID
                       AND QTENTRCONSOL > 1;
                     IF SQL%NOTFOUND THEN
                        DELETE ITEMCONSSOLOL
                        WHERE ROWID = C_ITEMCONS.ROWID;
                     END IF;
                  END IF;
               END LOOP;
               UPDATE ITEMSOLI
                  SET QTSOLIPROD = QTSOLIPROD  - V_QTDFINAL
                WHERE CDFILSOLI    = P_CDFILSOLI
                  AND CDFILLAN     = SUBSTR(V_NRSOLCOMP, 11, 4)
                  AND NRSOLICMP    = SUBSTR(V_NRSOLCOMP, 1, 10)
                  AND CDPRODUTO    = SUBSTR(V_NRSOLCOMP, 15, 10)
                  AND DTPROGENTR   = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                  AND NRSEQUCONSOL = P_NRSEQCONSOL
                  AND QTSOLIPROD - V_QTDFINAL > 0;
               IF SQL%NOTFOUND THEN
                  DELETE
                    FROM ITEMSOLI
                   WHERE CDFILSOLI    = P_CDFILSOLI
                     AND CDFILLAN     = SUBSTR(V_NRSOLCOMP, 11, 4)
                     AND NRSOLICMP    = SUBSTR(V_NRSOLCOMP, 1, 10)
                     AND CDPRODUTO    = SUBSTR(V_NRSOLCOMP, 15, 10)
                     AND DTPROGENTR   = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                     AND NRSEQUCONSOL = P_NRSEQCONSOL;
               END IF;
               INSERT INTO MOVOPSOL
                          (CDFILSOLMOV,
                           CDFILLANMOV,
                           NRSOLIMOV,
                           CDPRODUTO,
                           DTENTROPER,
                           DTOPERSOL,
                           CDOPERADOR,
                           QTANTOPER,
                           QTDEPOPER,
                           DSJUSTOPER)
                        SELECT
                           ITEMSOLI.CDFILSOLI,
                           ITEMSOLI.CDFILLAN,
                           ITEMSOLI.NRSOLICMP,
                           ITEMSOLI.CDPRODUTO,
                           ITEMSOLI.DTPROGENTR,
                           SYSDATE,
                           P_CDOPERADOR,
                           QTSOLIPROD - V_QTDFINAL,
                           QTSOLIPROD,
                           'EMPENHO DE OL - REJEIO'
                        FROM ITEMSOLI
                        WHERE CDFILSOLI    = P_CDFILSOLI
                          AND CDFILLAN     = SUBSTR(V_NRSOLCOMP, 11, 4)
                          AND NRSOLICMP    = SUBSTR(V_NRSOLCOMP, 1, 10)
                          AND CDPRODUTO    = SUBSTR(V_NRSOLCOMP, 15, 10)
                          AND DTPROGENTR   = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                          AND NRSEQUCONSOL = P_NRSEQCONSOL;
            END IF;
         END IF;
      ELSE -- PREVISAO CONSUMO
         FOR C_ITEMCONSSOLOL IN
           (SELECT DISTINCT
               I.CDFILSOLI,
               I.CDFILLAN,
               I.CDPRODUTO,
               I.DTENTRCONSOL,
               I.QTENTRCONSOL,
               NVL(P.VRFATOCONV, 1) VRFATOCONV,
               NVL(P.VRARREDCMP, 1) VRARREDCMP,
               --R.DTNCPREVCONSOL AS DTPROGENTR -- FOI SUBISTITUIDO POR DTENTRCONSOL PARA TESTAR
               R.DTNCPREVCONSOL AS DTPROGENTR
            FROM
               ITEMCONSSOLOL I, PRODUTO P, RELACONSOLOLNC R
            WHERE I.NRSEQUCONSOL = P_NRSEQCONSOL
              AND I.CDFILSOLI    = P_CDFILIOPELOG
              AND P.CDPRODESTO   = P_CDPRODESTO
              AND P.CDPRODUTO    = I.CDPRODUTO
              AND I.NRSEQUCONSOL = R.NRSEQUCONSOL
              --AND I.CDFILLAN     = R.CDFILLANCONS   /*ALTERAO SAPORE 28-10-2016*/
              AND I.DTENTRCONSOL = R.DTENTRCONSOL
              AND I.CDPRODUTO    = R.CDPRODUTOCONS
              AND R.CDFILSOLCONS = P_CDFILSOLI
              AND P_NRNECECOMP   = R.NRNCPREVCONSOL
            ORDER BY
              R.DTNCPREVCONSOL)
         LOOP
            V_VRARREDEMPE := 0;
            SELECT
               NVL(MAX(VRARREDEMPE), 0)
            INTO
               V_VRARREDEMPE
            FROM
               PRODFORNCOMP
            WHERE
               (CDFORNECED  = V_CDFORNEOL) AND
               (CDPRODCOMPL = C_ITEMCONSSOLOL.CDPRODUTO);
            IF V_VRARREDEMPE > 0 THEN
               IF V_QTARETIRAR > 0 THEN
                  SELECT
                     MAX(R.NRNCPREVCONSOL||R.CDFILLANCONS||R.CDPRODUTOCONS||TO_CHAR(R.DTNCPREVCONSOL, 'DD/MM/YYYY'))
                   INTO
                     V_NRSOLCOMP
                  FROM
                     RELACONSOLOLNC R
                  WHERE C_ITEMCONSSOLOL.CDFILSOLI     = R.CDFILSOLCONS
                    AND C_ITEMCONSSOLOL.CDFILLAN      = R.CDFILLANCONS
                    AND C_ITEMCONSSOLOL.CDPRODUTO     = R.CDPRODUTOCONS
                    AND C_ITEMCONSSOLOL.DTPROGENTR    = R.DTNCPREVCONSOL
                    AND P_NRSEQCONSOL                 = R.NRSEQUCONSOL
                    AND P_CDFILSOLI                   = R.CDFILIAL;
                  /* USO DO SUBSELECT PARA O CLCULO DE V_QTDEAUX E V_QTSOLIPROD EM UM S SELECT PARA GANHAR PERFORMANCE*/
                  SELECT SL1.QTDE, CEIL(SL1.QTDE/C_ITEMCONSSOLOL.VRFATOCONV)
                    INTO V_QTSOLIPROD, V_QTDEAUX
                  FROM
                  (
                     SELECT
                        MAX(TRABNECECOMP.QTTEORNECCMP * PRODUTO.VRFATOCONV) AS QTDE
                     FROM
                        TRABNECECOMP,
                        PRODUTO
                     WHERE TRABNECECOMP.CDFILNECECMP = P_CDFILSOLI
                       --AND TRABNECECOMP.CDFILLAN   = SUBSTR(V_NRSOLCOMP, 11, 4)
                       AND TRABNECECOMP.NRNECECOMP = SUBSTR(V_NRSOLCOMP, 1, 10)
                       AND TRABNECECOMP.CDPRODNECCMP = SUBSTR(V_NRSOLCOMP, 15, 10)
                       AND TRABNECECOMP.DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                       AND TRABNECECOMP.CDPRODNECCMP = PRODUTO.CDPRODUTO
                       AND TRABNECECOMP.NRNECECOMP = P_NRNECECOMP
                  )SL1;
                  IF V_QTSOLIPROD <= V_QTARETIRAR THEN /* O ITEM DA SOLICITACAO SERA EXCLUIDO CASO TENHA QUE RETIRAR UMA QUANTIDADE MAIOR QUE A SUA PROPRIA */
                     /* LOG DE ALTERAO NO SER GRAVADO NESSE CASO*/
                     DELETE FROM TRABNECECOMP
                     WHERE
                        (CDFILNECECMP = P_CDFILSOLI)    AND
                        (NRNECECOMP   = SUBSTR(V_NRSOLCOMP, 1, 10))  AND
                        (CDPRODNECCMP = SUBSTR(V_NRSOLCOMP, 15, 10)) AND
                        (DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY'));
                     IF C_ITEMCONSSOLOL.QTENTRCONSOL > V_QTDEAUX THEN
                        UPDATE ITEMCONSSOLOL
                           SET QTENTRCONSOL = QTENTRCONSOL - V_QTDEAUX
                         WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                           AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                           AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                           AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL
                           AND NRSEQUCONSOL = P_NRSEQCONSOL
                           AND QTENTRCONSOL - V_QTDEAUX > 0;
                        IF SQL%NOTFOUND THEN
                           DELETE FROM ITEMCONSSOLOL
                           WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                             AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                             AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                             AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL
                             AND NRSEQUCONSOL = P_NRSEQCONSOL;
                        END IF;
                     ELSE
                        DELETE FROM ITEMCONSSOLOL
                        WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                          AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                          AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                          AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL
                          AND NRSEQUCONSOL = P_NRSEQCONSOL;
                     END IF;
                     V_QTARETIRAR  := V_QTARETIRAR  - V_QTSOLIPROD;
                     V_QTAEMPENHAR := V_QTAEMPENHAR - (V_QTDEAUX * C_ITEMCONSSOLOL.VRFATOCONV);
                  ELSE
                     /* LOG DE ALTERAO NO SER GRAVADO NESSE CASO*/
                     UPDATE TRABNECECOMP
                     SET QTTEORNECCMP = QTTEORNECCMP - V_QTARETIRAR
                     WHERE
                        (CDFILNECECMP  = P_CDFILSOLI)    AND
                        (NRNECECOMP  = SUBSTR(V_NRSOLCOMP, 1, 10))  AND
                        (CDPRODNECCMP  = SUBSTR(V_NRSOLCOMP, 15, 10)) AND
                        (QTTEORNECCMP > V_QTARETIRAR)              AND
                        (DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY'));
                     V_QTARETIRAR := 0;
                  END IF; -- V_QTSOLIPROD <= V_QTARETIRAR
               END IF; -- V_QTARETIRAR > 0
               IF V_QTARETIRAR = 0 THEN  /* SE O REMANEJAMENTO DAS ENTREGAS ANTERIORES FOI FINALIZADO NO "IF" ACIMA, ESTE "IF" IRA VERIFICAR SE SERA NECESSARIO FAZER OUTRO REMANEJAMENTO PUXANDO DE ENTREGAS FUTURAS */
                  SELECT
                     MAX(R.NRNCPREVCONSOL||R.CDFILLANCONS||R.CDPRODUTOCONS||TO_CHAR(R.DTNCPREVCONSOL, 'DD/MM/YYYY'))
                   INTO
                     V_NRSOLCOMP
                  FROM
                     RELACONSOLOLNC R
                  WHERE C_ITEMCONSSOLOL.CDFILSOLI     = R.CDFILSOLCONS
                    AND C_ITEMCONSSOLOL.CDFILLAN      = R.CDFILLANCONS
                    AND C_ITEMCONSSOLOL.CDPRODUTO     = R.CDPRODUTOCONS
                    AND C_ITEMCONSSOLOL.DTPROGENTR    = R.DTNCPREVCONSOL
                    AND P_NRSEQCONSOL                 = R.NRSEQUCONSOL
                    AND P_CDFILSOLI                   = R.CDFILIAL;
                  IF V_NRSOLCOMP IS NOT NULL THEN  /* SE AINDA EXITIR SOLICITACAO PARA ESTA ENTREGA... */
                     SELECT SL1.QTDE, CEIL(SL1.QTDE/C_ITEMCONSSOLOL.VRFATOCONV)
                     INTO V_QTSOLIPROD, V_QTDEAUX
                     FROM
                     (
                        SELECT
                           MAX(TRABNECECOMP.QTTEORNECCMP * PRODUTO.VRFATOCONV) AS QTDE
                        FROM
                           TRABNECECOMP,
                           PRODUTO
                        WHERE TRABNECECOMP.CDFILNECECMP = P_CDFILSOLI
                          AND TRABNECECOMP.NRNECECOMP = SUBSTR(V_NRSOLCOMP, 1, 10)
                          AND TRABNECECOMP.CDPRODNECCMP = SUBSTR(V_NRSOLCOMP, 15, 10)
                          AND TRABNECECOMP.DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                          AND TRABNECECOMP.CDPRODNECCMP = PRODUTO.CDPRODUTO
                          AND TRABNECECOMP.NRNECECOMP = P_NRNECECOMP
                     )SL1;
                     V_QTARETIRAR := (V_QTDEAUX * C_ITEMCONSSOLOL.VRFATOCONV) - V_QTSOLIPROD;
                     IF V_QTARETIRAR > 0 THEN
   /*################################ AJUSTANDO V_QTARETIRAR PARA O VALOR QUE TEM DISPONIVEL PARA REMANEJAR ###############################*/
                        SELECT
                           MAX(R.DTNCPREVCONSOL)
                        INTO
                           V_DTULTENTR
                        FROM
                           RELACONSOLOLNC R
                        WHERE R.CDPRODUTOCONS = C_ITEMCONSSOLOL.CDPRODUTO
                          AND R.CDFILSOLCONS  = C_ITEMCONSSOLOL.CDFILSOLI
                          AND R.CDFILIAL      = P_CDFILSOLI
                          AND R.NRSEQUCONSOL  = P_NRSEQCONSOL;
                        SELECT
                           SUM(TRABNECECOMP.QTTEORNECCMP * PRODUTO.VRFATOCONV) INTO V_QTDISPONIVEL
                        FROM
                           TRABNECECOMP,
                           PRODUTO
                        WHERE TRABNECECOMP.CDFILNECECMP =  P_CDFILSOLI
                          AND PRODUTO.CDPRODESTO        =  P_CDPRODESTO
                          AND TRABNECECOMP.DTENTRNECCMP >  TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                          AND TRABNECECOMP.DTENTRNECCMP <= V_DTULTENTR
                          AND TRABNECECOMP.CDPRODNECCMP =  PRODUTO.CDPRODUTO
                          AND TRABNECECOMP.NRNECECOMP   = P_NRNECECOMP;
                        IF NVL(V_QTDISPONIVEL, 0) > 0 THEN
                           IF V_QTARETIRAR > NVL(V_QTDISPONIVEL, 0) THEN
                              V_QTARETIRAR := NVL(V_QTDISPONIVEL, 0);
                           END IF;
                        END IF;
                        /*ALTERAO DAVIDSON*/
                        V_QTARRED := V_QTARETIRAR/C_ITEMCONSSOLOL.VRFATOCONV;
                        V_QTARRED_AUX := 0;
                        /*ALTERAAO V_QTARETIRAR POR V_QTSOLIPROD*/
                        IF V_QTSOLIPROD > 0 AND V_QTSOLIPROD < 1 THEN
                           V_QTARRED_AUX   := V_QTARRED*C_ITEMCONSSOLOL.VRFATOCONV;
                        END IF;
                        IF C_ITEMCONSSOLOL.VRARREDCMP > 0 THEn
                           V_QTARRED := FLOOR(V_QTARRED / C_ITEMCONSSOLOL.VRARREDCMP) * C_ITEMCONSSOLOL.VRARREDCMP; /* TEM QUE ARREDONDAR PARA BAIXO PARA NAO TIRAR MAIS DO QUE DEVIA */
                        END IF;
                        IF V_VRARREDEMPE > 0 THEN
                           V_QTARRED := FLOOR(V_QTARRED / V_VRARREDEMPE) * V_VRARREDEMPE; /* TEM QUE ARREDONDAR PARA BAIXO PARA NAO TIRAR MAIS DO QUE DEVIA */
                        END IF;
                        IF V_QTARRED > 0 THEN
                           IF C_ITEMCONSSOLOL.QTENTRCONSOL > V_QTARRED THEN
                              UPDATE ITEMCONSSOLOL
                              SET QTENTRCONSOL   = QTENTRCONSOL - V_QTARRED
                              WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                                AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                                AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                                AND NRSEQUCONSOL = P_NRSEQCONSOL
                                AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL
                                AND QTENTRCONSOL - V_QTARRED > 0;
                              IF SQL%NOTFOUND THEN
                                 DELETE
                                   FROM ITEMCONSSOLOL
                                  WHERE CDFILSOLI    = C_ITEMCONSSOLOL.CDFILSOLI
                                    AND CDFILLAN     = C_ITEMCONSSOLOL.CDFILLAN
                                    AND CDPRODUTO    = C_ITEMCONSSOLOL.CDPRODUTO
                                    AND NRSEQUCONSOL = P_NRSEQCONSOL
                                    AND DTENTRCONSOL = C_ITEMCONSSOLOL.DTENTRCONSOL;
                              END IF;
                              V_QTAEMPENHAR := V_QTAEMPENHAR - (V_QTARRED * C_ITEMCONSSOLOL.VRFATOCONV);
                              V_QTARETIRAR  := V_QTARETIRAR  - (V_QTARRED * C_ITEMCONSSOLOL.VRFATOCONV);
                           END IF;
                        ELSE
                           IF V_QTARRED_AUX > 0 THEN
                              SELECT
                                 MAX(PRODUTO.VRFATOCONV) INTO V_VRFATOCONV
                              FROM
                                 TRABNECECOMP,
                                 PRODUTO
                              WHERE TRABNECECOMP.CDFILNECECMP  = P_CDFILSOLI
                                AND TRABNECECOMP.NRNECECOMP   = SUBSTR(V_NRSOLCOMP, 1, 10)
                                AND TRABNECECOMP.CDPRODNECCMP = SUBSTR(V_NRSOLCOMP, 15, 10)
                                AND TRABNECECOMP.DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                                AND TRABNECECOMP.CDPRODNECCMP = PRODUTO.CDPRODUTO;
                              V_QTAEMPENHAR := V_QTAEMPENHAR - (V_QTARRED_AUX * V_VRFATOCONV);
                              V_QTARETIRAR  := V_QTARETIRAR  - (V_QTARRED_AUX * V_VRFATOCONV);
                              /*ALTERAAO DAVIDSON DE V_QTARETIRAR = 0 PARA V_QTARETIRAR <= 0*/
                              IF (V_QTARRED_AUX * V_VRFATOCONV) > 0 AND V_QTARETIRAR <= 0 THEN
                                 V_QTARETIRAR := (V_QTARRED_AUX * V_VRFATOCONV);
                              END IF;
                           END IF; -- V_QTARRED_AUX > 0
                        END IF; -- V_QTARRED > 0
                        IF V_QTARETIRAR > 0 THEN
                           IF V_QTARETIRAR <= V_QTAEMPENHAR THEN
                              SELECT
                                 MAX(PRODUTO.VRFATOCONV) INTO V_VRFATOCONV
                              FROM
                                 TRABNECECOMP,
                                 PRODUTO
                              WHERE TRABNECECOMP.CDFILNECECMP  = P_CDFILSOLI
                                AND TRABNECECOMP.NRNECECOMP   = SUBSTR(V_NRSOLCOMP, 1, 10)
                                AND TRABNECECOMP.CDPRODNECCMP = SUBSTR(V_NRSOLCOMP, 15, 10)
                                AND TRABNECECOMP.DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                                AND TRABNECECOMP.CDPRODNECCMP = PRODUTO.CDPRODUTO;
                              /* LOG DE ALTERAO NO SER GRAVADO NESSE CASO*/
                              UPDATE TRABNECECOMP
                              SET QTTEORNECCMP = QTTEORNECCMP + V_QTARETIRAR/V_VRFATOCONV
                              WHERE
                                 (CDFILNECECMP  = P_CDFILSOLI)    AND
                                 (NRNECECOMP  = SUBSTR(V_NRSOLCOMP, 1, 10))  AND
                                 (CDPRODNECCMP  = SUBSTR(V_NRSOLCOMP, 15, 10)) AND
                                 (DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY'));
                           END IF; -- V_QTARETIRAR <= V_QTAEMPENHAR
                        END IF; -- V_QTARETIRAR > 0
                     END IF; -- V_QTARETIRAR > 0
                  ELSE --SE NO EXITIR MAIS SOLICITACAO PARA ESTA ENTREGA, TRAZ APENAS A QUANTIDADE AUXILIAR
                     SELECT CEIL(SL1.QTDE/C_ITEMCONSSOLOL.VRFATOCONV)
                     INTO V_QTDEAUX
                     FROM
                     (
                        SELECT
                           MAX(TRABNECECOMP.QTTEORNECCMP * PRODUTO.VRFATOCONV) AS QTDE
                        FROM
                           TRABNECECOMP,
                           PRODUTO
                        WHERE TRABNECECOMP.CDFILNECECMP = P_CDFILSOLI
                          AND TRABNECECOMP.NRNECECOMP   = SUBSTR(V_NRSOLCOMP, 1, 10)
                          AND TRABNECECOMP.CDPRODNECCMP = SUBSTR(V_NRSOLCOMP, 15, 10)
                          AND TRABNECECOMP.DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                          AND TRABNECECOMP.CDPRODNECCMP = PRODUTO.CDPRODUTO
                          AND TRABNECECOMP.NRNECECOMP   = P_NRNECECOMP
                     )SL1;
                  END IF; -- V_NRSOLCOMP IS NOT NULL
               END IF; -- V_QTARETIRAR = 0
            END IF; -- V_VRARREDEMPE > 0
            V_VRFATCONVOL   := C_ITEMCONSSOLOL.VRFATOCONV;
            V_CDPRODEMPENHO := C_ITEMCONSSOLOL.CDPRODUTO;
            V_ARREDCMPROWID := CASE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 0)
                                  WHEN  0
                                  THEN  1
                                  ELSE NVL(C_ITEMCONSSOLOL.VRARREDCMP, 0)
                               END;
         END LOOP; -- CURSOR ITEMCONSSOL
         SELECT
            SUM(TR.QTTEORNECCMP*NVL(PR.VRFATOCONV, 1))
         INTO
            V_QTDESOLDEPOIS
         FROM
            TRABNECECOMP TR, PRODUTO PR
         WHERE TR.CDFILNECECMP          = P_CDFILSOLI
           AND PR.CDPRODESTO            = P_CDPRODESTO
           AND PR.CDPRODUTO             = TR.CDPRODNECCMP
           AND TR.CDFILNECECMP          <> P_CDFILIOPELOG
           AND TR.CDFILIOPELOG          = P_CDFILIOPELOG
           AND TR.NRNECECOMP            = P_NRNECECOMP;
         V_QTDERESTSOL := V_QTDESOLDEPOIS - V_QTDETOTALSOL;
         IF V_QTDERESTSOL > 0 THEN
            FOR C_ITEMSOLI_FINAL IN
               (
               SELECT
                  TR.ROWID,
                  TR.CDFILNECECMP AS CDFILSOLI,
                  '' AS CDFILLAN,
                  TR.NRNECECOMP AS NRSOLICMP,
                  (TR.QTTEORNECCMP*NVL(PR.VRFATOCONV, 1)) QTSOLIPROD,
                  NVL(PR.VRARREDCMP, 0) VRARREDCMP,
                  NVL(PR.VRFATOCONV, 1) VRFATOCONV
               FROM
                  TRABNECECOMP TR, PRODUTO PR
               WHERE TR.CDFILNECECMP  = P_CDFILSOLI
                 AND PR.CDPRODESTO    = P_CDPRODESTO
                 AND PR.CDPRODUTO     = TR.CDPRODNECCMP
                 AND TR.CDFILNECECMP <> P_CDFILIOPELOG
                 AND TR.CDFILIOPELOG  = P_CDFILIOPELOG
                 AND TR.NRNECECOMP    = P_NRNECECOMP
               ORDER BY
                  DTENTRNECCMP DESC,
                  (TR.QTTEORNECCMP*NVL(PR.VRFATOCONV, 1)) DESC
               )
            LOOP
               /*                                                                               *\
                  SE NO POSSUIR VALOR PARA A FILIAL SOLICITANTE, RETORNA O VALOR DA FILIAL OL,
                  CASO CONTRRIO RETORNA ZERO E A PROCEDURE NO CONSIDERA O PARMETRO
               \*                                                                     */
               IF V_QTDERESTSOL > 0 THEN
                  V_ROWID := C_ITEMSOLI_FINAL.ROWID;
                  IF C_ITEMSOLI_FINAL.QTSOLIPROD > V_QTDERESTSOL THEN
                     V_QTDEAUX := V_QTDERESTSOL/C_ITEMSOLI_FINAL.VRFATOCONV;
                     IF C_ITEMSOLI_FINAL.VRARREDCMP > 0 THEN
                        V_QTDEAUX := FLOOR(V_QTDEAUX / C_ITEMSOLI_FINAL.VRARREDCMP) * C_ITEMSOLI_FINAL.VRARREDCMP;
                     END IF;
                     IF V_QTDEAUX > 0 THEN
                        /* LOG DE ALTERAO NO SER GRAVADO NESSE CASO*/
                        BEGIN
                           UPDATE TRABNECECOMP
                           SET QTORIGNECCMP = NVL(QTORIGNECCMP, QTTEORNECCMP),
                               QTTEORNECCMP = QTTEORNECCMP - V_QTDEAUX
                           WHERE ROWID = C_ITEMSOLI_FINAL.ROWID;
                        EXCEPTION
                           WHEN OTHERS THEN BEGIN
                              UPDATE TRABNECECOMP
                              SET QTTEORNECCMP = QTTEORNECCMP - V_QTDEAUX
                              WHERE ROWID = C_ITEMSOLI_FINAL.ROWID;
                           END;
                        END;
                        SELECT MAX(P_NRNECECOMP||CDPRODNECCMP||TO_CHAR(DTENTRNECCMP, 'DD/MM/YYYY'))
                          INTO V_NRSOLCOMP
                          FROM TRABNECECOMP
                         WHERE TRABNECECOMP.ROWID = C_ITEMSOLI_FINAL.ROWID;
                        V_QTDERESTSOL := 0;
                     END IF; -- V_QTDEAUX > 0
                  ELSE
                     SELECT COUNT(1)
                     INTO V_COUNT
                     FROM TRABNECECOMP, PRODUTO P
                     WHERE CDFILNECECMP = C_ITEMSOLI_FINAL.CDFILSOLI
                       AND NRNECECOMP = C_ITEMSOLI_FINAL.NRSOLICMP
                       AND P.CDPRODESTO = P_CDPRODESTO
                       AND P.CDPRODUTO = TRABNECECOMP.CDPRODNECCMP;
                     IF NVL(V_COUNT, 0) > 1 THEN
                        /* LOG DE ALTERAO NO SER GRAVADO NESSE CASO*/
                        DELETE FROM TRABNECECOMP
                        WHERE ROWID = C_ITEMSOLI_FINAL.ROWID;
                        V_QTDERESTSOL := V_QTDERESTSOL - C_ITEMSOLI_FINAL.QTSOLIPROD;
                     END IF;
                  END IF; -- C_ITEMSOLI_FINAL.QTSOLIPROD > V_QTDERESTSOL
               END IF; -- V_QTDERESTSOL > 0
            END LOOP; -- CURSOR ITEMSOLI_FINAL
         ELSE
            IF V_QTDERESTSOL < 0 THEN
               FOR C_ITEMSOLI_FINAL IN
                  (
                  SELECT
                     TR.ROWID,
                     NVL(PR.VRARREDCMP, 0) VRARREDCMP,
                     NVL(PR.VRFATOCONV, 1) VRFATOCONV
                  FROM
                     TRABNECECOMP TR, PRODUTO PR
                  WHERE TR.CDFILNECECMP  = P_CDFILSOLI
                    AND PR.CDPRODESTO    = P_CDPRODESTO
                    AND PR.CDPRODUTO     = TR.CDPRODNECCMP
                    AND TR.CDFILNECECMP <> P_CDFILIOPELOG
                    AND TR.CDFILIOPELOG  = P_CDFILIOPELOG
                    AND TR.NRNECECOMP    = P_NRNECECOMP
                  ORDER BY
                     DTENTRNECCMP,
                     (TR.QTTEORNECCMP*NVL(PR.VRFATOCONV, 1))
                  )
               LOOP
                  V_QTDEAUX := ABS(V_QTDERESTSOL/C_ITEMSOLI_FINAL.VRFATOCONV);
                  V_ROWID   := C_ITEMSOLI_FINAL.ROWID;
                  IF C_ITEMSOLI_FINAL.VRARREDCMP > 0 THEN
                     V_QTDEAUX := CEIL(V_QTDEAUX / C_ITEMSOLI_FINAL.VRARREDCMP) * C_ITEMSOLI_FINAL.VRARREDCMP;
                  END IF;
                  /* LOG DE ALTERAO NO SER GRAVADO NESSE CASO*/
                  BEGIN
                      UPDATE TRABNECECOMP
                      SET QTORIGNECCMP = NVL(QTORIGNECCMP, QTTEORNECCMP),
                          QTTEORNECCMP = QTTEORNECCMP + V_QTDEAUX
                      WHERE TRABNECECOMP.ROWID = C_ITEMSOLI_FINAL.ROWID;
                  EXCEPTION
                     WHEN OTHERS THEN BEGIN
                        UPDATE TRABNECECOMP
                        SET QTTEORNECCMP = QTTEORNECCMP + V_QTDEAUX
                        WHERE TRABNECECOMP.ROWID = C_ITEMSOLI_FINAL.ROWID;
                     END;
                  END;
                  SELECT MAX(P_NRNECECOMP||CDPRODNECCMP||TO_CHAR(DTENTRNECCMP, 'DD/MM/YYYY'))
                    INTO V_NRSOLCOMP
                    FROM TRABNECECOMP
                   WHERE TRABNECECOMP.ROWID = C_ITEMSOLI_FINAL.ROWID;
                  EXIT;
               END LOOP;
            END IF; -- V_QTDERESTSOL < 0
         END IF; -- V_QTDERESTSOL > 0

         SELECT MAX(NVL(PF.VRMINEMPENHOOL, NVL(PFOL.VRMINEMPENHOOL, 0)))
           INTO V_REJEICAOOL
           FROM PRODFILI PF, TRABNECECOMP TR, PRODFILI PFOL, PRODUTO
          WHERE TR.CDFILNECECMP = P_CDFILSOLI
            AND TR.CDPRODNECCMP = PRODUTO.CDPRODESTO
            AND PF.CDFILIAL     = P_CDFILSOLI
            AND PF.CDPRODUTO    = PRODUTO.CDPRODUTO
            AND PF.CDPRODUTO    = PFOL.CDPRODUTO
            AND PFOL.CDFILIAL   = TR.CDFILIOPELOG
            AND PFOL.CDPRODUTO  = V_CDPRODEMPENHO
            AND NVL(TR.NRNECECOMP, '1')   = P_NRNECECOMP
            AND NVL(TR.CDFILIOPELOG, '1') = P_CDFILIOPELOG;

         IF V_REJEICAOOL > 0 THEN
            V_AJUSTAR  := V_VRFATCONVOL;
            IF V_VRFATCONVOL = 1 AND V_ARREDCMPROWID > 1 THEN
               V_AJUSTAR := V_ARREDCMPROWID;
            END IF;
            SELECT MAX(SL1.QTDE)
              INTO V_QTDFINAL
            FROM
            (
               SELECT
                  MAX(TRABNECECOMP.QTTEORNECCMP * PRODUTO.VRFATOCONV) AS QTDE
               FROM
                  TRABNECECOMP,
                  PRODUTO
               WHERE TRABNECECOMP.CDFILNECECMP = P_CDFILSOLI
                 AND TRABNECECOMP.NRNECECOMP = SUBSTR(V_NRSOLCOMP, 1, 10)
                 AND TRABNECECOMP.CDPRODNECCMP = SUBSTR(V_NRSOLCOMP, 15, 10)
                 AND TRABNECECOMP.DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                 AND TRABNECECOMP.CDPRODNECCMP = PRODUTO.CDPRODUTO
                 AND TRABNECECOMP.NRNECECOMP = P_NRNECECOMP
            )SL1;
            V_QTDFINAL := MOD(V_QTDFINAL, V_AJUSTAR);
            IF (V_QTDFINAL < (V_AJUSTAR*V_REJEICAOOL/100) AND (V_QTDFINAL > 0)) THEN
               FOR C_ITEMCONS IN(
                  SELECT
                     I.ROWID,
                     I.QTENTRCONSOL
                  FROM
                     ITEMCONSSOLOL I, PRODUTO P, RELACONSOLOLNC R,
                     (
                        SELECT TR.DTENTRNECCMP, P_NRSEQCONSOL AS NRSEQUCONSOL
                        FROM TRABNECECOMP TR
                        WHERE TR.CDFILNECECMP = P_CDFILSOLI
                          AND TR.NRNECECOMP = SUBSTR(V_NRSOLCOMP, 1, 10)
                          AND TR.CDPRODNECCMP = SUBSTR(V_NRSOLCOMP, 15, 10)
                          AND TR.DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                          AND TR.NRNECECOMP = P_NRNECECOMP
                    ) ITS
                  WHERE I.NRSEQUCONSOL = P_NRSEQCONSOL
                    AND I.CDFILSOLI    = P_CDFILIOPELOG
                    AND P.CDPRODESTO   = P_CDPRODESTO
                    AND P.CDPRODUTO    = I.CDPRODUTO
                    AND I.NRSEQUCONSOL = R.NRSEQUCONSOL
                    AND R.NRSEQUCONSOL = ITS.NRSEQUCONSOL
                    AND I.CDFILLAN     = R.CDFILLANCONS
                    AND I.DTENTRCONSOL = R.DTENTRCONSOL
                    AND I.CDPRODUTO    = R.CDPRODUTOCONS
                    AND R.CDFILSOLCONS = P_CDFILSOLI
                    AND R.DTNCPREVCONSOL   = ITS.DTENTRNECCMP
               ) LOOP
                  IF V_VRFATCONVOL = 1 AND V_ARREDCMPROWID > 1 THEN
                     UPDATE ITEMCONSSOLOL
                     SET QTENTRCONSOL = QTENTRCONSOL - 1*V_AJUSTAR
                     WHERE ROWID = C_ITEMCONS.ROWID
                       AND QTENTRCONSOL > 1*V_AJUSTAR;
                     IF SQL%NOTFOUND THEN
                        DELETE ITEMCONSSOLOL
                        WHERE ROWID = C_ITEMCONS.ROWID;
                     END IF;
                  ELSE
                     UPDATE ITEMCONSSOLOL
                     SET QTENTRCONSOL = QTENTRCONSOL - 1
                     WHERE ROWID = C_ITEMCONS.ROWID
                       AND QTENTRCONSOL > 1;
                     IF SQL%NOTFOUND THEN
                        DELETE ITEMCONSSOLOL
                        WHERE ROWID = C_ITEMCONS.ROWID;
                     END IF;
                  END IF;
               END LOOP;
               UPDATE TRABNECECOMP
                  SET QTTEORNECCMP = QTTEORNECCMP - V_QTDFINAL
                WHERE CDFILNECECMP = P_CDFILSOLI
                  AND NRNECECOMP = SUBSTR(V_NRSOLCOMP, 1, 10)
                  AND CDPRODNECCMP = SUBSTR(V_NRSOLCOMP, 15, 10)
                  AND DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                  AND NRNECECOMP = P_NRNECECOMP
                  AND QTTEORNECCMP - V_QTDFINAL > 0;
               IF SQL%NOTFOUND THEN
                  DELETE
                    FROM TRABNECECOMP
                   WHERE CDFILNECECMP = P_CDFILSOLI
                     AND NRNECECOMP = SUBSTR(V_NRSOLCOMP, 1, 10)
                     AND CDPRODNECCMP = SUBSTR(V_NRSOLCOMP, 15, 10)
                     AND DTENTRNECCMP = TO_DATE(SUBSTR(V_NRSOLCOMP, 25, 10), 'DD/MM/YYYY')
                     AND NRNECECOMP = P_NRNECECOMP;
               END IF;
            END IF;
         END IF;
      END IF;
   END IF;
END;